if (!('viewMode' in window.localStorage))
    window.localStorage.viewMode = "tiled";

if (!('currentList' in window.localStorage))
    window.localStorage.currentList = "menuSolutionPark";

if (!('currentSol' in window.localStorage))
    window.localStorage.currentSol = "CDSB";

if (!('solInfoStatus' in window.localStorage))
    window.localStorage.solInfoStatus = false;

if (!('pref_active_tab' in window.localStorage))
    window.localStorage.pref_active_tab = "CDSB_ACCOUNT";

var defaults = {
    btns_width: 0
}

var current = {
    listIDs: {
        menuSolutionPark: "",
        menuConceptDraw: "",
        menuCD: "",
        menuMM: "",
        menuPR: "",
        menuUpdates: "",
        menuInstalled: ""
    },
    uninstallIDs : {}
};

function onlyUnique(value, index, self) {
    return self.indexOf(value) === index;
}

function getCurrentCmd() {
    var cmd = "";
    if (window.localStorage.currentList == "menuAbout")
        cmd = "CDSB_ABOUT";
    /*        else if (window.localStorage.currentList == "menuTimes")
    cmd = "CDSB_TIMES";             */
    else if (window.localStorage.currentList == "menuPrefs")
        cmd = window.localStorage.pref_active_tab;

    return cmd;
}

function isCommandUrl(cmd) {
    var urlCmds = ["CDSB_NEWS", "CDSB_HELP", "CDSB_MYACCOUNT", "CDSB_CHECKFORUPD"];
    return urlCmds.indexOf(cmd) != -1;
}

function setServerId(x) {
    if (typeof x == 'undefined') {
        //alert('aaaa!');
        return;
    }

    window.localStorage.currentSol = x;
    current.listIDs[window.localStorage.currentList] = x;

    var visited_items = window.localStorage.visited_items ? JSON.parse(window.localStorage.visited_items) : [];
    visited_items.push(x);
    window.localStorage.visited_items = JSON.stringify(visited_items.filter( onlyUnique ));
    updateUnvisitedCount();
    
    $('.sl-item').has('#' + x).addClass('sl-view');
    
    console.log("serverId: ");
    console.log("\twindow.localStorage.currentSol: " + window.localStorage.currentSol);
    console.log("\twindow.localStorage.currentList: " + window.localStorage.currentList);
};

function loadMain() {

    var item = '#' + window.localStorage.currentList;
    $('.menu').find(item).addClass('active');

    updateUserInfo();
    //    updateTimesMenu();
    updateUpdatesCount();
    updateUnvisitedCount();

    $(window).unload(function() {
        dialog_pane_hide();
    });

    $('.tools .up-tool').click(function() {
        multiInstall();
        return false;
    });

    $('.tools .delete-tool').click(function() {
        multiUnInstall();
        return false;
    });

    $('.tools .all').click(function() {
        toolsSelectAll();
        return false;
    });

    $('.tools .none').click(function() {
        toolsSelectNone();
        return false;
    });

    $('.input-search').focusin(function() {
        searchFocus(this);
    });

    $('.input-search').focusout(function() {
        searchFocusOut(this);
    });

    $('.input-search').keydown(function(eventObject) {
        if (eventObject.which == 13) 
            searchApply(this);
    });

    $(".topMenu td").click(function() {

        if (!$(this).parent().hasClass('empty')) {

            var newId = $(this).parent().attr('id');

            if ($(this).parent().attr('id') == 'filter-product-row') {
                $(this).parent().find(".expand_collapse_area").click();

                return false;
            }

            if ($(this).parent().attr('id') == 'links-group') {
                $(this).parent().find(".expand_collapse_area").click();

                return false;
            }

            /*
            if ($(this).parent().attr('id') == 'menuTimes') {
            showTimes();
            return false;
            }
            else*/
            if ($(this).parent().attr('id') == 'menuHelp') {
                OnHelp();
                return false;
            }
            else if ($(this).parent().attr('id') == 'menuNews') {
                OnNews();
                return false;
            }
            else if ($(this).parent().attr('id') == 'menuAbout') {
                toolsHide();
                showAboutDlg();
                return false;
            }
            else if ($(this).parent().attr('id') == 'menuPrefs') {
                toolsHide();
                showPrefDlg("CDSB_PROXY");
                return false;
            }

            $('table.menu').find('.active').toggleClass('active');
            $(this).parent().toggleClass('active');
            $('.input-search').val('Search');
            $('.input-search').prop('disabled', false);

            toolsHide();

            // Animation 1
            $('.content-wraper-full').animate({ opacity: 0 }, 300);
            $('.s-list').animate({ opacity: 0 }, 300);

            loadSolutionList($(this).parent().attr('id'), function() {
                selectSolInList(window.localStorage.currentSol);
                scrollToSolInList(window.localStorage.currentSol);
                setupSolItemChecks();
                loadSolution(window.localStorage.currentSol);
                $(".times-wrapper").hide();
                dialog_pane_hide();

                // Animation 2
                $('.content-wraper-full').animate({ opacity: 1 }, 300);
                $('.s-list').animate({ opacity: 1 }, 300);
            });
        }

        return false;
    });

    $(".bottomMenu td").click(function() {
        /*else */if ($(this).parent().attr('id') == 'menuAccount')
            OnAccount();
        else if ($(this).parent().attr('id') == 'menuCheck')
            OnUpdate();

        return false;
    });

	$(".chkup-tool").click(function() {
	    var info = get_about_info();
	    OnUpdate();
	    if (info.Synchronized == "true") {
	        updateUserInfo();
	    }
        return false;
    });

	$("a.more-info").click(function() {
	    $(this).closest('.check_btn').toggleClass('active');
	    window.localStorage.solInfoStatus = $(this).closest('.check_btn').hasClass('active');
	    if (String (window.localStorage.solInfoStatus) == 'true') {
	        $("#s_desc_web").animate({ height: "show" }, 500);
	        $("a.more-info").attr("title", $("a.more-info").attr("optitle"));
	    }
	    else {
	        $("#s_desc_web").animate({ height: "hide" }, 500);
	        $("a.more-info").attr("title", $("a.more-info").attr("cltitle"));
	    }

        return false;
    });

    var listedAndTiledAnimation = function() {
        var result = {};
        var obj = $('#s_content .cnt');
        var pos = obj.position();

        var obj2 = $('#s_desc');
        var pos2 = obj2.position();

        if (typeof pos == "undefined")
            return result;

        console.log(pos2.top);

        result['scrollTop'] = pos.top - pos2.top;
        console.log(result);

        return result;
    };

    $("a.listed").click(function() {
        $(this).parent().parent().find('.active').toggleClass('active');
        $(this).parent().toggleClass('active');
        $('#s_content').animate({ opacity: 0 }, 300, function() {
            var sol = "get_content?" + $('table.active td.stitle span').attr('id');
            $('#s_content').load(sol + '  #sc_content_listed', function() {
                $("table.lsamples h2").click(function() {
                    ($(this).closest('tr').find('a').click()/*attr('href')*/);
                    return false;
                });
            });
            $('#s_content').animate({ opacity: 1 }, 300);
            $('.content-wraper-full').animate(listedAndTiledAnimation(), 500, 'swing');
        });

        window.localStorage.viewMode = "listed";

        return false;
    });

	$("a.tiled").click(function() {
	    $(this).parent().parent().find('.active').toggleClass('active');
	    $(this).parent().toggleClass('active');
	    $('#s_content').animate({ opacity: 0 }, 300, function() {
	        var sol = "get_content?" + $('table.active td.stitle span').attr('id');
	        $('#s_content').load(sol + '  #sc_content_tiled');
	        $('#s_content').animate({ opacity: 1 }, 300);
	        $('.content-wraper-full').animate(listedAndTiledAnimation(), 500, 'swing');
	    });

	    window.localStorage.viewMode = "tiled";
	    
	    return false;
	});
    
    var w_dp = $(".sb-wrapper").width() - $(".s-col").width();
    $('.dialog-pane').css("left", w_dp + "px");

    var cmd = document.URL.split('?')[1];

    var loadCurrentFilter = function() {
        if (!parseCommand(getCurrentCmd()))
            loadSolutionList(window.localStorage.currentList, function() {
                selectSolInList(window.localStorage.currentSol);
                scrollToSolInList(window.localStorage.currentSol);
                setupSolItemChecks();
                loadSolution(window.localStorage.currentSol);
            });
    };

    if (typeof cmd == "undefined") {
            loadCurrentFilter();
        } else {

        console.log("cmd=" + cmd);
    
        if (isCommandUrl(cmd)) {
            parseCommand(cmd);
            loadCurrentFilter();
        } 
        else if (!parseCommand(cmd))
            loadCurrentFilter();
    }

    if (window.platform() == "win")
        $('#modalOverlay .spinner').load("spinner.html .spinner");
    else if (window.platform() == "mac")
        $('#modalOverlay .spinner').load("spinner_mac.html .spinner");
} // end LoadMain

function loadSolutionList(type, onload) {

    window.localStorage.currentList = type;

    var param = type;
    var filter = $('.input-search').val();

    if (filter != "" && filter != "Search") {
        filter = encodeURIComponent(filter.trim());
        param = type + "&" + filter;
    }

    //$('.ajax-loader').show();

/*  Move to setupList
    // Save status downloading
    var downloads = [];
    $('table.s-list .downloading').each(function() {
        downloads.push($(this).find('.stitle span').attr('id'));
    });
*/

    $('#s_list').load('select_list?' + param, function() {

        defaults.btns_width = $('.btns').width();

        updateUpdatesCount();

        $("td.stitle").unbind('click').click(function() {

            var sol_id = $(this).find('span').attr('id');

            selectSolInList(sol_id);
            loadSolution(sol_id);

            return false;
        });

        $(".atitle").unbind('click').click(function() {
            $(this).find('.expand_collapse_area').click();
            /*
            $('#s_list').find('.active').toggleClass('active');
            var area_id = $(this).attr('id');

            $('#s_content').hide();
            $('table.all-view').hide();
            $('#s_desc_wrapper').hide();
            $('#s_desc_web').hide();
            $('td.title h5').hide();
            $('#sol_area').text('Area');
            $('#sol_title').text($(this).find('span').text());

            var url = "get_area_desc?" + area_id; // +"   body";

            $('#sc_desc').load(url, function() {
            //                 $('#sol_title').text($(this).find('h1').text());
            //                 $(this).find('h1').hide();
            });
            */
            return false;
        });

        setupList();

        $('.atitle').each(function(indx, element) {
            $(element).attr('title', get_area_desc($(element).attr('id')));
        });

        // expand_collapse_area

        $('.atitle .expand_collapse_area').each(function(indx, element) {
            $(element).attr('optitle', 'Collapse the list of solutions');
            $(element).attr('cltitle', 'Expand the list of solutions');
        });

        ecSetup();

        $(".btns .inst").unbind('click').click(function() {
            var sol_id = $(this).parent().parent().find('.stitle span').attr('id');
            if (DoInstall(sol_id))
                showInstProgress(sol_id, this);

            return false;
        }); /* click inst */

        $(".btns .up").unbind('click').click(function() {
            var sol_id = $(this).parent().parent().find('.stitle span').attr('id');
            if (DoInstall($(this).parent().parent().find('.stitle span').attr('id')))
                showInstProgress(sol_id, this);

            return false;
        }); /* click up */

        $(".btns .cancel").unbind('click').click(function() {

            var sol_id = $(this).closest('tr').find('.stitle span').attr('id');
            hideInstProgress(sol_id, this);
            doCancelDownload(sol_id);

            return false;

        }); /* click cancel */

        $(".btns .done").unbind('click').click(function() { return false; });

        $("a.prop").unbind('click').click(function() {
            /* $(this).parent().find('.up').toggle(); */
            $(this).toggle();
            $(this).parent().find('.wait').fadeIn('slow', function() {
                $(this).fadeOut('slow', function() {
                    $(this).parent().find('.up').fadeIn('fast');
                });
            });

            return false;
        });

        if (current.listIDs[window.localStorage.currentList] != "" &&
                                        findSolInList(current.listIDs[window.localStorage.currentList])) {

            setServerId(current.listIDs[window.localStorage.currentList]);
            selectSolInList(window.localStorage.currentSol);
            loadSolution(window.localStorage.currentSol);
        }
        else
            if (!findSolInList(window.localStorage.currentSol)) {
            {
                var find = false;
                for (item in current.listIDs) {
                    if (item != window.localStorage.currentList && current.listIDs[item] != "" &&
                                        findSolInList(current.listIDs[item])) {
                        setServerId(current.listIDs[item]);
                        find = true;
                        break;
                    }
                }

                if (!find)
                    setServerId(firstSolInList());
            }

            selectSolInList(window.localStorage.currentSol);
            loadSolution(window.localStorage.currentSol);
        }

        /*      Move to setupList
        // Restore status downloading
        $('table.s-list .sol_tr').each(function() {
        var cur_sol = $(this).find('.stitle span').attr('id');
        if (downloads.indexOf(cur_sol) != -1) {
        $(this).addClass('downloading');
        showInstProgress(cur_sol, ac_button_by_id(cur_sol));
        }
        });
        */


        onload();

        //$('.ajax-loader').hide();
    });
}

function product_requirements_text(req_code, sol_id) {
    return product_requirements_name(req_code, sol_id) + " v.&nbsp;" +
           product_requirements_ver(req_code, sol_id) + " or&nbsp;later";
}

function need_install_products(sol_id) {
    return  need_install_product("CDPRO", sol_id) ||
            need_install_product("CDPRJ", sol_id) ||
            need_install_product("CDMM", sol_id);
}

function setupReqItem(sol_id, req_code, element) {
    if (need_install_product(req_code, sol_id)) {

        element.html(product_requirements_text(req_code, sol_id));

        if (need_update_to_ver(req_code, product_requirements_ver(req_code, sol_id))) {
            element.removeClass("checked");
            element.html("<a href='#' class='bgetit' req='" + req_code + "' title='Install the application'>" +
                                product_requirements_name(req_code, sol_id) +
                         "</a>" + " v.&nbsp;" +
                         product_requirements_ver(req_code, sol_id) + " or&nbsp;later"
            );
            element.css("list-style-image", "url(images/warning.png)");
        }
        else {
            element.addClass("checked");
        }
        element.show();

    }
    else {
        element.hide();
    }
}

function nextSelSolution(sol_id) {

    var solutions = [];

    $('.stitle span').each(function(indx, sol) {
        solutions.push($(sol).attr('id'));
    });

    var i = solutions.indexOf(sol_id);
    if (i >= 0)
        solutions.splice(i, 1);

    if (i >= 0 && i < solutions.length)
        return solutions[i];

    if (--i >= 0 && i < solutions.length)
        return solutions[i];
       
    return '';
}


function loadSolution(sol_id, onLoad) {

    var info = get_about_info();
    if (info.Online != "false" && info.OfflineMode != "true") {
        $('a.more-info').show();
        $('#s_desc_web_wrapper').show();
    }
    else {
        $('a.more-info').hide();
        $('#s_desc_web_wrapper').hide();
    }
    if ($("#s_list").text() == "Nothing to display") {
        $(".sol-nothing").show();
        return;
    }
    else
        $(".sol-nothing").hide();

    sol = "get_content?" + sol_id;

    var need_animate = window.localStorage.currentSol != sol_id;

    setServerId(sol_id);

    $('.uninstall-link').hide();

    $('.uninstall-link').unbind('click').click(function() {
        console.log("$('.uninstall-link').click() sol_id: " + sol_id);
        DoUnInstall(sol_id);

        return false;
    });

    $("#s_desc_web").hide();
    $("#s_desc_web").load(web_url_by_code(window.localStorage.currentSol), function() {
        $("div.solution-content a").unbind('click').click(function() {
            OpenExtUrl($(this).attr('href'));
            return false;
        });
    });

    if (String(window.localStorage.solInfoStatus) == 'true' && info.Online!= "false") {
        $("a.more-info").closest('.check_btn').addClass('active');
        $("a.more-info").attr("title", $("a.more-info").attr("optitle"));
        if (need_animate)
            $("#s_desc_web").show();
        else
            $("#s_desc_web").animate({ height: "show" }, 500);
    }
    else {
        $("a.more-info").closest('.check_btn').removeClass('active');
        $("a.more-info").attr("title", $("a.more-info").attr("cltitle"));
    }
    loadSolution.load = function() {
        if ($('.sl-item').hasClass("active")) {
            $('#sol_title').text($('table.active td.stitle span').text());
            $('#sol_area').text($('table.active').parent().parent().parent().prev().find('td').text());
            $('#aria_desc').text('sdjfshdf sdhfsk');
        }
        $('#s_desc').load(sol + '  #sc_desc', function() {

            var inst = is_installed(sol_id);

            if (inst) {
                /* alert('installed') */
                $(".inswr").toggle();
                $('td.switch').removeClass('active');
                if (window.localStorage.viewMode == "tiled") {
                    $('#s_content').load(sol + '  #sc_content_tiled', function() {
                        checkContent();
                        $('#s_content').show();
                    });
                    $('.switch-tiled').addClass('active');
                } else {
                    $('#s_content').load(sol + '  #sc_content_listed', function() {
                        checkContent();
                        $('#s_content').show();
                        $("table.lsamples h2").click(function() {
                            ($(this).closest('tr').find('a').click()/*attr('href')*/);
                            return false;
                        });
                    });
                    $('.switch-listed').addClass('active');
                }
                // $('.view').fadeIn('slow');

                if (isProduct(sol_id)) {
                    if (window.platform() == "win")
                        $('#uninstall-prod').show();
                }
                else
                    $('#uninstall-sol').show();

            } else {
                $('.view').fadeOut('fast');
                /* alert('not installed') */
                $("a.more-info").closest('.check_btn').addClass('active');
                if (need_animate)
                    $("#s_desc_web").show();
                else
                    $("#s_desc_web").animate({ height: "show" }, 500);
                $("a.more-info").attr("title", $("a.more-info").attr("optitle"));
            }

            if (window.platform() == "mac") {
                var h = $('#inst_btn').height();
                $('#inst_btn').remove();
                $('#buy_btn').remove();
                $('#inst_btn_mac').attr('id', 'inst_btn');
                $('#buy_btn_mac').attr('id', 'buy_btn');
                $('div.instbutton .spinner').remove();

                $('div.instbutton .button').height(h);
                $('div.instbutton .button').css('border-radius', h / 2 + 'px');
                $('div.instbutton .button').css('font-size', '125%');

                $('#inst_btn').show();
            }
            else {
                $('div.instbutton .barber-pole').remove();
                $('div.instbutton .spinner').removeClass('spinner');
                $('div.instbutton .wait').load("spinner.html .spinner");
            }


            if (!isFree(sol_id) && !has_license(sol_id)) {
                $('.offer').show();
                $('.offer b').text(product_price_comment(sol_id));
                $('#inst_btn').hide();
                $('#buy_btn').show();
                $('#buy_btn .price').text(product_price(sol_id));
            } else {
                $('div.instbutton').css("border-top-color", "transparent");
            }

            if (isProduct(sol_id)) {
                $('#inst_btn').text("Install this product");
            }


            if (need_install_products(sol_id)) {
                setupReqItem(sol_id, "CDPRO", $("#CDPRO_REQ"));
                setupReqItem(sol_id, "CDPRJ", $("#CDPRJ_REQ"));
                setupReqItem(sol_id, "CDMM", $("#CDMM_REQ"));
                $("#colReq").show();
            }
            else {
                $("#colReq").hide();
            }

            $('.bgetit').click(function() {
                window.localStorage.currentSol = $(this).attr('req');
                $('#menuConceptDraw td:first-child').click();
                current.listIDs[window.localStorage.currentList] = x;
                return false;
            });

            $('td.title h5').text(product_version(sol_id, window.localStorage.currentList == "menuInstalled"));

            $('table.all-view').show();
            $('td.title h5').show();

            $("ul.wilist li").hover(
			  function() {

			      var id = "#" + $(this).attr('id').split('_')[0];

			      $("#emt").toggle();

			      $(id).toggle();
			      $(id).animate({ opacity: 1 }, 300);

			  },
			  function() {
			      $("#emt").toggle();
			      var id = "#" + $(this).attr('id').split('_')[0];
			      $(id).animate({ opacity: 0 }, 300, function() {

			      });
			      $(id).toggle();
			  }
			);

            $("#inst_btn").click(function() {

                console.log("#inst_btn click()");

                if (DoInstall(window.localStorage.currentSol))
                    showInstProgress(window.localStorage.currentSol, ac_button_by_id(window.localStorage.currentSol));

                return false;
            });

            $('#buy_btn').click(function() {
                OpenExtUrl("https://my.conceptdraw.com/scripts/bs.php?code=" + window.localStorage.currentSol);
                return false;
            });


            $(".instbutton a.cancel").click(function() {

                var tr = $(".sol_tr").has('.stitle #' + sol_id);
                var cancel_btn = $(tr).find('.btns .cancel');

                hideInstProgress(window.localStorage.currentSol, cancel_btn);
                doCancelDownload(sol_id);

                return false;
            });

            if (isProduct(window.localStorage.currentSol)) {
                $("a.more-info").html("PRODUCT&nbsp;INFO");
                $("a.more-info").attr("title", replaceSolutionProduct($("a.more-info").attr("title")));
                $("a.more-info").attr("optitle", replaceSolutionProduct($("a.more-info").attr("optitle")));
                $("a.more-info").attr("cltitle", replaceSolutionProduct($("a.more-info").attr("cltitle")));
            }
            else {
                $("a.more-info").html("SOLUTION&nbsp;INFO");
                $("a.more-info").attr("title", replaceProductSolution($("a.more-info").attr("title")));
                $("a.more-info").attr("optitle", replaceProductSolution($("a.more-info").attr("optitle")));
                $("a.more-info").attr("cltitle", replaceProductSolution($("a.more-info").attr("cltitle")));
            }

            if ($('#' + window.localStorage.currentSol).closest('.sol_tr').hasClass('downloading') && !$('#' + window.localStorage.currentSol).closest('.sol_tr').hasClass('installing'))
                showInstProgress(window.localStorage.currentSol, ac_button_by_id(window.localStorage.currentSol));

            $('td.s-col div.content-wraper-full').scrollTop(0);

            if (typeof onLoad != 'undefined')
                onLoad();
        });
    }                        /*);*/


    if (need_animate) {
        $('.content-wraper-full').animate({ opacity: 0 }, 300, function() {
            loadSolution.load();
            $('.content-wraper-full').animate({ opacity: 1 }, 300);
        });
    }
    else
        loadSolution.load();

    do_set_size();
 }

 function showAboutDlg() {
     var info = get_about_info();

     $('table.menu').find('.active').removeClass('active');
     $('#menuAbout').addClass('active');

     $(".times-wrapper").hide();
     $('.input-search').val('Search');
     $('.input-search').prop('disabled', true);
     $(".s-list-nothing").hide();
     window.localStorage.currentList = 'menuAbout';

     $('.dialog-pane').load("about.html", function() {

         $("#about_version").text(info.Version);
         $("#about_system").text(info.System);
         $("#about_user_agent").text(info.UserAgent);
         $("#about_reginfo").text(info.RegInfo);
         $("#about_sdi").text(info.HDI);

         $("#about_app_path").text(info.AppPath);
         $("#about_sp_path").text(info.SPPath);

         $('.dialog-pane').show();
     });
     
     $('#s_list').load("list_item.html", function() {
        $('#s_list .stitle span').text("About ConceptDraw Solution Browser");
         $('#s_list .sl-item').addClass("active");
     });
 }

function OnAccount() 
{
	OpenExtUrl("https://my.conceptdraw.com/account/profile.php");
    //$('#modalOverlay').fadeIn('slow', function() {
/*
        $.post("https://my.conceptdraw.com/registration/login.php",
            {
                email: "*****@csodessa.com",
                password: "******",
                form_login: "Sign In",
                remember_login: 1
            }, 
            function (data) { alert(data); });
*/
    //});
}

function OnHelp() 
{
	OpenExtUrl("http://www.conceptdraw.com/helpdesk/index.php");
}

function OnNews() 
{
    OpenExtUrl("http://www.conceptdraw.com/news/list.php");
}

function showCart(sol_id, element, show) {
    if (show) {
        
        $(element).find('.cart').show();

        $(element).find('.cart').unbind('click').click(function() {
            OpenExtUrl("https://my.conceptdraw.com/scripts/bs.php?code=" + sol_id);
            return false;
        });
    } else {
        $(element).find('.cart').hide();
        $('.price').hide();
    }
}

function selectSolInList(sol_id) {
    $('#s_content').show();
    $('#s_list').find('.active').removeClass('active');
    $("td.stitle").find('#' + sol_id).closest('.sl-item').addClass('active');
    $('#s_content table').replaceWith('<div></div>');
}

function scrollToSolInList(sol_id) {

    var obj = $('table.s-list tr.sol_tr:has(span[id=' + sol_id + '])');

    var h = $(obj).height();
    if ($(obj).index() * h < $('.s-list-wrapper').height() - h) {    // Item visible with area title (Feature #3403)
        obj = $(obj).parent().prev().find('tr');    // Scroll to area title
    }
    
    var pos = obj.position();

    if (typeof pos == "undefined")
        return;

    $('div.s-list-wrapper').scrollTop(0);
    pos = obj.position();
    $('div.s-list-wrapper').scrollTop(pos.top);
}

function  setupSolItemChecks() 
{
    $("div.check").unbind('click').click(function() {
        /*
        $(this).find('.check-in').fadeToggle('fast', function() {
        setupUpTool();
        });
        */
        $(this).find('.check-in').toggleClass('check-in_v check-in_h');
        setupUpTool();

        return false;
    });
}

function setStatusInstalling(obj) {

    var $btns = obj.find('.btns');
    $btns.attr("style", "");
    
    $(obj).removeClass('downloading');
    $(obj).find('.prgr').hide();
    $(obj).find('.sol_action').hide();
    $(obj).find('.wait').show();
    $(obj).addClass('installing');
}

function eventProgressDownloading(sol_id, progress) {
    console.log('Progress: ' + sol_id + " = " + progress);
    var obj = $('table.s-list tr.sol_tr').has('#' + sol_id);
    //  $(obj).addClass('downloading');
    
    if (progress >= 0)
        $(obj).find('.pba-w').width(progress * 80 / 100);

    if (progress >= 0 && sol_id == window.localStorage.currentSol) {
        $(".instbutton .progress").width(
                176 * progress / 100);
    }

    showInstProgress(sol_id);
}

function eventReadyForInstall(sol_id) {
    console.log('eventReadyForInstall: ' + sol_id);
    
    var obj = $('table.s-list tr.sol_tr:has(span[id=' + sol_id + '])');
    if (sol_id == window.localStorage.currentSol) {
            if (window.platform() == 'win')
                $(".instbutton .dwnl").hide();
            $(".instbutton #inst_btn").hide();
            $(".instbutton .progress").hide();
            $(".instbutton .cancel").hide();
            $('.instbutton .wait').show();
        }
    if ( ! $(obj).hasClass('installing') ) {
        setStatusInstalling(obj);

        
    }
}

function eventInstalled(sol_id) {
    console.log('eventInstalled: ' + sol_id);

    if (window.localStorage.currentList == 'menuInstalled') {
        addInstalledItem(sol_id);
        return;
    }
    
    var element = $('table.s-list tr.sol_tr:has(span[id=' + sol_id + '])');

    $(element).removeClass('installing');

    $(element).find('.prgr').hide();
    $(element).find('.pba-w').width(0);
    $(element).find('.sol_action').hide();
    /*$(element).find('.done').show();*/
    
    var $btns = $(element).find('.btns');
    $btns.attr("style", "");

    setDone(element);
    updateUpdatesCount();

    var visited_items = window.localStorage.visited_items ? JSON.parse(window.localStorage.visited_items) : [];
    visited_items.push(sol_id);
    window.localStorage.visited_items = JSON.stringify(visited_items.filter(onlyUnique));
    $('.sl-item').has('#' + sol_id).addClass('sl-view');
    
    updateUnvisitedCount();

    if (window.localStorage.currentSol == sol_id)
        loadSolution(window.localStorage.currentSol, function() {
            $('#s_content').show();
        });
}

function setElementDone(element) {
    var sol_id = $(element).find('span').attr('id');
    if (is_installed(sol_id)) {
        $(element).removeClass('downloading installing');
        $(element).find('.prgr').hide();
        $(element).find('.sol_action').hide();
        /*$(element).find('.done').show();*/

/*
        var $btns = $(element).find('.btns');
        $btns.animate({ width: $btns.css('width') }, 100);
*/
        setDone(element);

        if (window.localStorage.currentSol == sol_id)
            loadSolution(window.localStorage.currentSol);
    }
}

function setupInstalled() {
    $('.downloading').each(function(indx, element) {
        setElementDone(element);
    });
    $('.installing').each(function(indx, element) {
        setElementDone(element);
    });
}

function addInstalledItem(sol_id) {
    parseCommand("CDSB_INSTALLED");
}

function setupSolElement(element) {

    var showNew = true;

    if ($(element).find('span').text() == '##broken##') {
        $(element).closest('.sol_tr').hide();
        return;
    }

    var sol_id = $(element).find('span').attr('id');
    if (!isFree(sol_id) && !has_license(sol_id))
        showCart(sol_id, element, true);
    else if (need_update(sol_id)) {
        $(element).find('.up').show();
        showNew = false;
    }
    else if (is_installed(sol_id)) {
        setDone(element);
        showNew = false;
    }
    else
        $(element).find('.inst').show();

    if (!showNew)
        $(element).addClass('sl-view');

    if (isProduct(sol_id)) {
        $(element).find('.sol_action').each(function(index, action) {
            try {
                var title = $(action).attr('title');
                //console.log('Title: ' + title);
                if (typeof title != 'undefined' && title.match(/olution/g)) {
                    title = title.replace(new RegExp("Solution", 'g'), "Product");
                    title = title.replace(new RegExp("solution", 'g'), "product");
                    //console.log('Title2: ' + title);
                    $(action).attr('title', title);
                }
            } 
            finally {}
        });
    }
}

function setupList() {

    if ($("#s_list").text() == "Nothing to display") {
        $(".s-list-nothing").show();
        $(".s-list-nothing span").hide();


        var filter = $('.input-search').val();
        var hasFilter = (filter != "" && filter != "Search");
        
        if (window.localStorage.currentList == 'menuUpdates' && !hasFilter)
            $(".s-list-nothing span.no_updates").show();
        else if (window.localStorage.currentList == 'menuInstalled' && !hasFilter)
            $(".s-list-nothing span.no_installed").show();
        else
            $(".s-list-nothing span.nothing_found").show();
    }
    else {
        $(".s-list-nothing").hide();

        var visited_items = window.localStorage.visited_items ? JSON.parse(window.localStorage.visited_items) : [];
        $('.sl-item').each(function(indx, element) {
            setupSolElement(element);
        });

        for (i in visited_items) {
            $('.sl-item').has('#' + visited_items[i]).addClass('sl-view');
        }

        var downloads = get_downloading_products();
        for (i in downloads) {
            var code = downloads[i];
            $('.sol_tr').has('#' + code).addClass('downloading');
            showInstProgress(code, ac_button_by_id(code));
        }

        var installs = get_installing_products();
        for (i in installs) {
            var code = installs[i];
            $('.sol_tr').has('#' + code).addClass('installing');
            eventReadyForInstall(code);
        }
    }
}

function ac_button_by_id(sol_id) {

    var tr = $(".sol_tr").has('.stitle #' + sol_id);
    return $(tr).find('.btns .sol_action:visible');
}

function hideInstProgress(sol_code, ac_button) {
    $(ac_button).closest('.sol_tr').removeClass('downloading');
    $(sol_code).closest('.sol_tr').removeClass('downloading');
    $(ac_button).parent().find('.prgr').hide();
    $(ac_button).parent().find('.pba-w').width(0);    
    var $btns = $(ac_button).closest('.btns');
    $btns.attr("style", "");
    setupSolElement($(ac_button).closest(".sl-item"));
    $(ac_button).hide();
    if (sol_code == window.localStorage.currentSol)    
    {
        $(".instbutton #inst_btn").fadeIn('fast');
        $(".dwnl").hide();
        $(".instbutton .progress").width(0);	    
	    $(".instbutton a.cancel").hide();
	    $(".instbutton .wait").hide();
    }
}


function showInstProgress(sol_code, ac_button) {
    if (typeof sol_code == 'undefined' || sol_code == window.localStorage.currentSol) {
        $(".instbutton #inst_btn:visible").each(function(indx, element) {           
            if ($(ac_button).closest(".sol_tr").hasClass('downloading')) {
                $(".instbutton .inst").hide();
                 $(".dwnl").show();
                $(".instbutton a.cancel").show();
            }
        });
    }

    if (typeof sol_code != 'undefined' && typeof ac_button != 'undefined') {
        if ($(ac_button).closest(".sol_tr").hasClass('downloading') && !$(ac_button).closest(".sol_tr").hasClass('installing')) {
            $(ac_button).parent().animate({ width: '162px' }, 300, function() {
                $(ac_button).parent().find('.prgr').fadeIn('fast');
            });
            $(ac_button).hide();
            //$(ac_button).parent().closest('.sl-item').find('.new-item').hide();
            $(ac_button).parent().find('.cancel').show();
        }
    }
}

function multiInstall() {
    $('div.check .check-in_v').each(function(indx, check_element) {
        var row_el = $(check_element).closest('tr');
        /*$(check_element).hide();*/
        $(check_element).removeClass('check-in_v');
        $(check_element).addClass('check-in_h');
        $(row_el).find('.btns .sol_action:visible').click();
    });
    $('.tools').animate({ top: 40 }, 300, function() {
        $('.tools-wrapper').hide();
    });
}

var need_sel_next = false;
var indx_sel_next = -1;

function onUninstallEnd() {
    console.log("Call function onUninstallEnd()");
    if (need_sel_next) {

        if (indx_sel_next >= $('.sol_tr').size())
            indx_sel_next = $('.sol_tr').size() - 1;

        console.log("   indx = " + indx_sel_next);

        if (indx_sel_next >= 0) {
            var $next_tr = $('.sol_tr').eq(indx_sel_next);
            var next_id = $next_tr.find('.stitle span').attr('id')

            console.log("   next_id = " + next_id);

            $next_tr.find('.sl-item').addClass('active');
            loadSolution(next_id);
        }
        need_sel_next = false;
        indx_sel_next = -1;
    }
}


function multiUnInstall() {
    need_sel_next = false;
    indx_sel_next = -1;
    $('div.check .check-in_v').each(function(i, check_element) {

        if (i == 0)
            indx_sel_next = $('div.check .check-in').index(check_element);

        var row_el = $(check_element).closest('tr');

        /*$(check_element).hide();*/
        $(check_element).removeClass('check-in_v');
        $(check_element).addClass('check-in_h');

        code = $(row_el).find('.stitle span').attr('id');
        if (window.localStorage.currentSol == code && window.localStorage.currentList == 'menuInstalled')
            need_sel_next = true;
        DoUnInstall(code);
    });

    console.log("Call function multiUnInstall()");
    console.log("   need_sel_next = " + need_sel_next);
    console.log("   indx = " + indx_sel_next);
    
    $('.tools').animate({ top: 40 }, 300, function() {
        $('.tools-wrapper').hide();

        /*
        loadSolutionList(window.localStorage.currentList, function() {
        selectSolInList(window.localStorage.currentSol);
        scrollToSolInList(window.localStorage.currentSol);
        setupSolItemChecks();
        loadSolution(window.localStorage.currentSol);
        });
        */
    });
}

function onCancelUninstallItem(code) {
    var row = $(".stitle #" + code).closest(".sl-item");
    $(row).find('.wait').hide();
    window.setTimeout(function () {
        setupSolElement(row);
    }, 1000);

    window.clearTimeout(current.uninstallIDs[code]);
}

function onCancelInstallItem(code) {
//    console.log("onCancelInstallItem(" + code + ")");

    var $installing = $('#' + code).closest('.installing');
    var $downloading = $('#' + code).closest('.downloading');

    $installing.removeClass('installing');
    $downloading.removeClass('downloading');

    if ($installing.length > 0 || $downloading.length > 0)
        hideInstProgress(code, ac_button_by_id(code));
//     else
//         console.log("\tSkiped");
}

function cancelAllDownloads() {
    $('table.s-list tr.sol_tr').each(function(indx, item) {        
        onCancelInstallItem($(item).find('.stitle span').attr('id'));
    });
}

function onUninstallItem(code) {

    var row = $(".stitle #" + code).closest(".sl-item");

    console.log("onUninstallItem(" + code + ")");

    if (window.localStorage.currentList == 'menuInstalled') {

        var sol_id = nextSelSolution(code);

        if (sol_id != '') {
            selectSolInList(sol_id);
            loadSolution(sol_id);
        }

        var sol_tr = $(row).closest('.sol_tr');
        var tbody = $(sol_tr).closest('tbody');

        $(sol_tr).remove();
        if ($(tbody).children('.sol_tr').size() == 0) {
            var thead = $(tbody).prev('thead');
            $(thead).remove();
            $(tbody).remove();
        }

        if ($('.sol_tr').size() == 0)
            searchApply();
    } else {
        $(row).removeClass("installed");
        $(row).find(".btns").children().hide();
        $(row).find(".btns").show();
        $(row).find(".inst").show();
        $(row).find(".stitle").removeClass('stitle-inst');

        if (window.localStorage.currentSol == code) {
            loadSolution(window.localStorage.currentSol, function() {
                $(".inswr").show();
                $('#s_content').hide();

                $("a.more-info").closest('.check_btn').addClass('active');
                $("#s_desc_web").animate({ height: "show" }, 500);
                $("a.more-info").attr("title", $("a.more-info").attr("optitle"));

                $('.uninstall-link').hide();
            });
        }
    }

    window.clearTimeout(current.uninstallIDs[code]);
    setTimeout(updateUpdatesCount, 1000);
    setTimeout(updateUnvisitedCount, 1000);
}

function toolsSelectAll() {
    $('div.check .check-in_h').each(function(indx, check_element) {
        /*$(check_element).show();*/
        $(check_element).removeClass('check-in_h');
        $(check_element).addClass('check-in_v');
    });

    setupUpTool();
}

function toolsSelectNone() {
    $('div.check .check-in_v').each(function(indx, check_element) {
        /*$(check_element).hide();*/
        $(check_element).removeClass('check-in_v');
        $(check_element).addClass('check-in_h');
    });

    toolsHide();
}

function toolsHide() {
    $('.tools').animate({ top: 40 }, 300, function() {
        $('.tools-wrapper').hide();
    });
}

function timeExpired(context, time_interval) {
    var expired = true;
    if (typeof context.time == 'undefined')
        context.time = 0;

    var now = time();
    if (now - context.time < time_interval)
        expired = false;

    context.time = now;

    return expired;
}

function setupUpTool() {

    if (!timeExpired(setupUpTool, 200))
        return;

    var updates = 0;
    var installs = 0;

    $('div.check .check-in_v').each(function(indx, el) {
        var row_el = $(el).closest('tr');
        var sol_id = $(row_el).find('.stitle span').attr('id');
        if (is_installed(sol_id))
            updates++;
        else
            installs++;
    });

    //alert(updates + " " + installs);

    $('.tools-wrapper').width($("td.b-col").width());

    if (updates || installs) {
        $('.tools-wrapper').show();
        $('.tools').animate({ top: 0 });

        if (updates && installs)
            $('.up-tool').text("Update & Install");
        else if (updates)
            $('.up-tool').text("Update");
        else
            $('.up-tool').text("Install");

    } else {
        $('.tools').animate({ top: 40 }, 300, function() {
            $('.tools-wrapper').hide();
        });
    } // if
}

function web_url_by_code(code) {

    if (code == "CDPRO")
        return "http://www.conceptdraw.com/products/drawing-tool/" + "  .entry-content";

    if (code == "CDMM")
        return "http://www.conceptdraw.com/products/mind-map/" + "  .entry-content";

    if (code == "CDPRJ")
        return "http://www.conceptdraw.com/products/project-management-software/" + "  .entry-content";


    return "http://www.conceptdraw.com/solution-park/sb/" + code + '  .solution-content';
}

function searchFocus(search) {
    if ($(search).val() == "Search")
        $(search).val("");
}

function searchFocusOut(search) {
    if ($(search).val() == "")
        $(search).val("Search");
}

function searchApply() {
    loadSolutionList(window.localStorage.currentList, function() {
        expandAriaForSolution(window.localStorage.currentSol);
        selectSolInList(window.localStorage.currentSol);
        scrollToSolInList(window.localStorage.currentSol);
        setupSolItemChecks();
        loadSolution(window.localStorage.currentSol);
    });
}

function onResize(width, height) {
    $(".s-list-wrapper").height(height - $(".top-tools").height());

    var newHeght = height - $("#s_header").parent().height();
    $(".content-wraper-full").height(newHeght);
    //$(".content-wraper-full").height(height - $("#s_header").parent().height());
}

function findSolInList(sol) {
    if ($('#s_list .atitle').is('#' + sol))
        return true;

    if ($('#s_list .stitle span').is('#' + sol))
        return true;

    return false;
}

function firstSolInList() {
    return $('#s_list .stitle span').first().attr('id');
}

function time() {
    return new Date().getTime();
}

function preferences_account_show() {
    $('.dialog-pane').load("preferences_account.html", function() {
        $('#account-item').addClass("active");

        var info = get_about_info();

        // synchronized
        if (info.userName != "") {
            $('#pref-user').text(info.userName);
            $('#pref-email').text(info.Login);

            $('.pref-synchronized').show();
            $('.pref-not-synchronized').hide();

            // Move '.account-form' to '.bottom-div' after 'div.switch'
            var $form = $('.account-form');
            //$form.detach();
            $form.insertAfter('.bottom-div div.switch');
            $form.hide();
        }

        // not synchronized
        else {
            $('.pref-synchronized').hide();
            $('.pref-not-synchronized').show();
            $('div.switch').hide();
        }

        preferences_account_init();
    });
}

/*
function preferences_sync_show() {
    $('.dialog-pane').load("preferences_sync.html", function() {
        preferences_sync_init();
        $('#sync-item').addClass("active");
    });
}
*/

function preferences_proxy_show() {
    $('.dialog-pane').load("preferences_proxy.html", function() {
        preferences_proxy_init();
        $('#proxy-item').addClass("active");
    });
}

function include(arr, obj) {
    return (arr.indexOf(obj) != -1);
}

function showPrefDlg(tab) {

    var tabs = (tab == "CDSB_PROXY") ? ["CDSB_PROXY"] : ["CDSB_ACCOUNT"];

    window.localStorage.pref_active_tab = tab;
    window.localStorage.currentList = 'menuPrefs';
    
    $(".times-wrapper").hide();
    $('.input-search').val('Search');
    $('.input-search').prop('disabled', true);
    $(".s-list-nothing").hide();

    $('table.menu').find('.active').removeClass('active');

    if (tab == "CDSB_PROXY")
        $('#menuPrefs').addClass('active');
    else
        $('#opt-item').closest('tr').addClass('active');
    

    $('#s_list').load("list_item.html", function() {

        var item = $('#s_list .sol_tr');

        $(item).clone(true).insertAfter(item);
        //$(item).clone(true).insertAfter(item);

        $('#s_list .sol_tr:nth-child(1) .sl-item').attr('id', 'account-item');
        $('#s_list .sol_tr:nth-child(2) .sl-item').attr('id', 'proxy-item');

        if (!include(tabs, "CDSB_ACCOUNT"))
            $('#account-item').remove();

        if (!include(tabs, "CDSB_PROXY"))
            $('#proxy-item').remove();

        $('#account-item .stitle span').text("Account");
        $('#proxy-item .stitle span').text("Proxy settings");

        $('#account-item').unbind('click').click(function() {
            window.localStorage.pref_active_tab = "CDSB_ACCOUNT";
            $('#s_list .sl-item').removeClass('active');
            preferences_account_show();
            return false;
        });
        $('#proxy-item').unbind('click').click(function() {
            window.localStorage.pref_active_tab = "CDSB_PROXY";
            $('#s_list .sl-item').removeClass('active');
            preferences_proxy_show();
            return false;
        });

        if (tab == "CDSB_ACCOUNT")
            preferences_account_show();
        else if (tab == "CDSB_PROXY")
            preferences_proxy_show();

        $('.dialog-pane').show();

    });
}

var inSync = false;

function on_preferences_sync_ok() {
    //$('.ajax-loader').show();
    //updateUserInfo();
    preferences_sync_ok(
                    $("input[name='account-email']").val(),
                    $("input[name='account-password']").val()
                );
}

function on_preferences_sync_success() {
    updateUserInfo();
    $('#modalOverlay').fadeOut('fast');
    preferences_account_show();
    var inSync = false;
    //$('.ajax-loader').hide();
}

function on_preferences_sync_failed() {
    $('#modalOverlay').fadeOut('fast');
    var inSync = false;
}

function preferences_account_init() {
    var info = get_about_info();
    //$("input[name='account-email']").val(info.Login);

    $("button[name='preferences_sync_ok']").unbind('click').click(function() {
        on_preferences_sync_ok();
        return false;
    });
    $("button[name='preferences_sync_cancel']").unbind('click').click(function() {
        $("input[name='account-email']").val(info.Login);
        $("input[name='account-password']").val("");
        return false;
    });
    $("input[name='account-email'], input[name='account-password']").keydown(function(eventObject) {
        if (eventObject.which == 13)
            on_preferences_sync_ok();
    });
/*
    $("a.Forgot_your_password").unbind('click').click(function() {
        OpenExtUrl("https://my.conceptdraw.com/account/pswreset.php");
        return false;
    });
*/
    $("button[name='sync_to_account']").unbind('click').click(function() {
        sync_to_account();
        return false;
    });

    $('.bottom-div .switch a').unbind('click').click(function() {
        $('.account-form').toggle();
        return false;
    });
}

/*
function preferences_sync_init() {
    $("button[name='sync_to_account']").unbind('click').click(function() {
        sync_to_account();
        return false;
    });
}
*/

function preferences_proxy_init() {
    var prefData = get_preferences_data();
    var $radios = $('input:radio[name=settings]');
    $radios.prop('checked', false);
    $radios.filter('[value=' + prefData.useProxy + ']').prop('checked', true);

    $("select[name='type']").val(prefData.proxyType);
    $("input[name='host']").val(prefData.proxyHost);
    $("input[name='host_port']").val(prefData.proxyPort);
    $("input[name='use_auth']").prop('checked', prefData.useAuthorization);
    $("input[name='login']").val(prefData.proxyLogin);
    $("input[name='pass']").val(prefData.proxyPassword);

    setupProxyControls();
    $radios.unbind('click').click(function() {
        setupProxyControls();
    });
    $("input[name='use_auth']").unbind('click').click(function() {
        setupProxyControls();
    });
}

function initPrefDlg() {

    preferences_account_init();
    
    /*preferences_sync_init();*/

    preferences_proxy_init();
}


function getProxyControlsState() {

    var $radios = $('input:radio[name=settings]');

    //var check = $("input[name='use_auth']").prop('checked');
    
    var prefData = {
        useProxy:           $radios.filter(':checked').val(),
        proxyType:          $("select[name='type']").val(),
        proxyHost:          $("input[name='host']").val(),
        proxyPort:          $("input[name='host_port']").val(),
        useAuthorization:   $("input[name='use_auth']").prop('checked'),
        proxyLogin:         $("input[name='login']").val(),
        proxyPassword:      $("input[name='pass']").val()
    }

    return prefData;
}

function setupProxyControls() {
    var proxyControlsState = getProxyControlsState();

    var manual      = proxyControlsState.useProxy == "MANUAL";
    var use_auth    = proxyControlsState.useAuthorization;

    $("select[name='type']").prop({ disabled: !manual });
    $("input[name='host']").prop({ disabled: !manual });
    $("input[name='host_port']").prop({ disabled: !manual });
    $("input[name='use_auth']").prop({ disabled: !manual });
    $("input[name='login']").prop({ disabled: !(manual && use_auth) });
    $("input[name='pass']").prop({ disabled: !(manual && use_auth) });
}

function applyProxyControlsState() {
    var proxyControlsState = getProxyControlsState();
    set_preferences_data(proxyControlsState);
}

function updateUserInfo() {
    var info = get_about_info();
    if (info.userName != "")
        $("#opt-item").text(info.userName);

    var $inet_stat = $(".inet-status");

    $inet_stat.toggleClass("inet-status-on inet-status-off", false);
    if (info.Online != "false") {
        $inet_stat.addClass("inet-status-on");
        $inet_stat.attr('title', 'Internet connection status: connected');
        $inet_stat.unbind('click');
        $inet_stat.css('cursor', 'default');
    }
    else {
        $inet_stat.addClass("inet-status-off");
        $inet_stat.attr('title', 'Internet connection status: disconnected. Check proxy settings in the Preferences');
        $inet_stat.css('cursor', 'pointer');
        $inet_stat.unbind('click').click(function() {
            showPrefDlg("CDSB_PROXY");
            return false;
        });
    }

    $("#opt-item").css('cursor', 'pointer');
    $("#opt-item").unbind('click').click(function() {
        showPrefDlg("CDSB_ACCOUNT");
        return false;
    });

//    ecSetup();
    
/*
    if (!info.Online || !info.Synchronized) {
        $("#opt-item .expand_collapse_area").removeClass("toggle-on");
        $("#opt-item .expand_collapse_area").addClass("toggle-off");
        window.localStorage['areaItemState_opt-item'] = "toggle-off";
    }
*/

//    $("#opt-item").attr('title', $("#opt-item .expand_collapse_area").attr('title'));

    if (info.userName != "") {
        $('#pref-user').text(info.userName);
        $('#pref-email').text(info.Login);
        $('.info').show();
        $('.my-account').css('display', 'block');
    }
    else {
        $('.info').hide();
        $('.my-account').hide();
        $("#opt-item").text('Connect to account');
    }

    return (info.userName != "");
}

/*
function updateTimesMenu() {
    $(".times-request").load("http://www.conceptdraw.com/timesrequest.html", function(data, textStatus, XMLHttpRequest) {
        if (textStatus != "error" && data != "" && data.replace(" ", "") != "")
            $("#menuTimes").show();
    });
}
 */

function AvailableProductsDidLoadFromDisk() {
    updateUpdatesCount();
    updateUnvisitedCount();

    if (window.localStorage.currentList == "menuSolutionPark" ||
        window.localStorage.currentList == "menuConceptDraw" ||
        window.localStorage.currentList == "menuCD" ||
        window.localStorage.currentList == "menuMM" ||
        window.localStorage.currentList == "menuPR" ||
        window.localStorage.currentList == "menuUpdates") {
        loadSolutionList(window.localStorage.currentList, function() {
            selectSolInList(window.localStorage.currentSol);
            scrollToSolInList(window.localStorage.currentSol);
            setupSolItemChecks();
            loadSolution(window.localStorage.currentSol);
        });
    }
}

function parseCommand(cmd) {

    if (typeof cmd == 'undefined' || cmd == "")
        return false;

    console.log("parseCommand(" + cmd + ")");
    
    if (cmd == "CDSB_SYNC")
        cmd = "CDSB_ACCOUNT";

    if (cmd == "CDSB_ACCOUNT" || cmd == "CDSB_PROXY")
        showPrefDlg(cmd);
    /*	else if (cmd == "CDSB_TIMES")
    $("#menuTimes td:nth-child(2)").click();    */
    else if (cmd == "CDSB_CDSP")
        $("#menuSolutionPark td:nth-child(2)").click();
    else if (cmd == "CDSB_CDOFF")
        $("#menuConceptDraw td:nth-child(2)").click();
    else if (cmd == "CDSB_CDPRO")
        $("#menuCD td:nth-child(2)").click();
    else if (cmd == "CDSB_CDMM")
        $("#menuMM td:nth-child(2)").click();
    else if (cmd == "CDSB_CDPRJ")
        $("#menuPR td:nth-child(2)").click();
    else if (cmd == "CDSB_AVAILABLE")
        $("#menuUpdates td:nth-child(2)").click();
    else if (cmd == "CDSB_INSTALLED")
        $("#menuInstalled td:nth-child(2)").click();
    else if (cmd == "CDSB_NEWS")
        OnNews();
    else if (cmd == "CDSB_HELP")
        OnHelp();
    else if (cmd == "CDSB_ABOUT")
        showAboutDlg();
    else if (cmd == "CDSB_MYACCOUNT")
        OnAccount();
    else if (cmd == "CDSB_CHECKFORUPD")
        $(".chkup-tool").click();
    //     else if (cmd == "CDSB_MYWORKSPACES")
    //         ;
    else if (cmd == "CDSB_SYNC_CALLBACK")
        preferences_sync_callback();
    else if (cmd.indexOf("CDSB_CANCELINSTALL") == 0)
        onCancelInstallItem(cmd.split('=')[1]);
    else if (cmd.indexOf("CDSB_CANCELDOWNLOAD") == 0)
        onCancelInstallItem(cmd.split('=')[1]);
    else if (cmd.indexOf("CDSB_CANCELALLDOWNLOADS") == 0)
        cancelAllDownloads();
    else if (cmd == "CDSB_RELOADINDEX")
        reloadIndex();
    else if (cmd == "CDSB_SHOWCONNECTTOACCAUNTMSG")
        showConnectToAccountMessage();
    else
        return false;

    return true;
}

function checkContent() {
    if ($("#s_content a[href='#']").size() == 0) {
        $("table.view").hide();
        $("table.cnt").hide();
    }
    else {
        $("table.view").show();
        $("table.cnt").show();
    }
}

function replaceSolutionProduct(src) {
    return src.replace("solution", "product").replace("Solution", "Product");
}

function replaceProductSolution(src) {
    return src.replace("product", "solution").replace("Product", "Solution");
}

function isProduct(sol_id) {
    return (sol_id == "CDPRO" || sol_id == "CDMM" || sol_id == "CDPRJ" || sol_id == "CDSB");
}

/*
function showTimes() {
    $(".times-wrapper").show();
    dialog_pane_hide();
    $('table.menu').find('.active').removeClass('active');
    $('#menuTimes').addClass('active');
    window.localStorage.currentList = 'menuTimes';
}
 */

function expandAriaForSolution(sol_id) {
    //alert(sol_id);
    var obj = $('table.s-list tr.sol_tr:has(span[id=' + sol_id + '])');

    $(obj).closest('tbody').prev('thead').find('.atitle').each(function(indx) {
        var expand_collapse = $(this).find('.expand_collapse_area');
        if ($(expand_collapse).hasClass('toggle-on')) {
            $(expand_collapse).toggleClass('toggle-off toggle-on');
            window.localStorage['areaItemState_' + sol_id] = "toggle-off";
            $(expand_collapse).attr('title', $(expand_collapse).attr('optitle'));
            $(obj).closest('tbody').show();
        }
    });
}

function SynchronousRequest(func, params) {
    var request = new XMLHttpRequest();
    var s = '/request?' + func;

    for (i in params) {
        s += '&' + encodeURIComponent (params[i]);
    }
    
    request.open('GET', s, false);  // `false` makes the request synchronous
    request.send(null);

    if (request.status === 200) {
        return request.responseText;
    }

    return null;
}

function SynchronousRequestXml(func, params) {
    var request = new XMLHttpRequest();
    var s = '/request_xml?' + func;

    for (i in params) {
        s += '&' + encodeURIComponent (params[i]);
    }

    request.open('GET', s, false);  // `false` makes the request synchronous
    request.send(null);

    if (request.status === 200) {
        alert(request.responseXml);
        return request.responseXml;
    }

    return null;
}

function showConnectToAccountMessage() {
    if (!inSync)
        SynchronousRequest('showConnectToAccountMessage');
}

function is_installed(sol_id) {
    var result = SynchronousRequest('is_installed', [sol_id]);
    return result != null && result != "false";
}

function need_update(sol_id) {
    var result = SynchronousRequest('need_update', [sol_id]);
    return result != null && result != "false";
}

function need_update_to_ver(sol_id, ver) {
    var result = SynchronousRequest('need_update_to_ver', [sol_id, ver]);
    return result != null && result != "false";
}

function updates_count() {
    return SynchronousRequest('updates_count');
}

var upd_data = false;

function OnUpdate() {

    upd_data = true;
    $('#modalOverlay').fadeIn('slow', function() { SynchronousRequest('OnUpdate'); });

    window.setTimeout(OnUpdate_Done, 1000 * 30);
}

function OnUpdate_Done() {
    if (upd_data) {
        $('#modalOverlay').fadeOut('fast');
        upd_data = false;
    }
}


function need_install_product(req_code, sol_id) {
    var result = SynchronousRequest('need_install_product', [req_code, sol_id]);
    return result != null && result != "false";
}

function product_requirements_ver(req_code, sol_id) {
    return SynchronousRequest('product_requirements_ver', [req_code, sol_id]);
}

function product_requirements_name(req_code, sol_id) {
    return SynchronousRequest('product_requirements_name', [req_code, sol_id]);
}

function product_version(sol_id, installed) {
    return SynchronousRequest('product_version', [sol_id, installed]);
}

function isFree(sol_id) {
    return SynchronousRequest('isFree', [sol_id]) != 'false';
}

function has_license(sol_id) {
    return SynchronousRequest('has_license', [sol_id]) != 'false';
}

function product_price(sol_id) {
    return SynchronousRequest('product_price', [sol_id]);
}

function product_price_comment(sol_id) {
    return SynchronousRequest('product_price_comment', [sol_id]);
}

function get_area_desc(code) {
    return SynchronousRequest('get_area_desc', [code]);
}

function DoInstall(code) {
    var info = get_about_info();
    if (info.Synchronized == "true") {
        $('.sol_tr').has('#' + code).addClass('downloading');
        SynchronousRequest('DoInstall', [code]);
        return true;
    }
    else {
        showConnectToAccountMessage();
        return false;
    }
}

function DoUnInstall(code) {
    current.uninstallIDs[code] = window.setTimeout(function() {
        $('#' + code).closest('.sl-item').find('.btns').children().hide(); 
        $('#' + code).closest('.sl-item').find('.wait').show();
    }, 500);
    SynchronousRequest('DoUnInstall', [code]);
}

function get_downloading_products() {
    return SynchronousRequest('get_downloading_products', []).split(',');
}

function get_installing_products() {
    return SynchronousRequest('get_installing_products', []).split(',');
}

function get_solution_park_list() {
    return SynchronousRequest('get_solution_park_list', []).split(',');
}

function get_unvisited_count(visited) {
    return SynchronousRequest('get_unvisited_count', visited);
}

function get_download_progress(code) {
    return SynchronousRequest('get_download_progress', [code]);
}

function doCancelDownload(code) {
    SynchronousRequest('doCancelDownload', [code]);
}

function do_set_size() {
    SynchronousRequest('do_set_size', []);
}

function OpenExtUrl(url) {
    if (!timeExpired(OpenExtUrl, 500))
        return;
        
    SynchronousRequest('OpenExtUrl', [url]);
}

function sync_to_account() {
    SynchronousRequest('sync_to_account', []);
}

function preferences_sync_callback() {
    SynchronousRequest('preferences_sync_callback', []);
}

function preferences_sync_ok(email, password) {
    inSync = true;
    $('#modalOverlay').fadeIn('slow', function() {
        SynchronousRequest('preferences_sync_ok', [email, password]);
    });
}

function set_preferences_data(data) {
    var s = JSON.stringify(data, null, 2);

    if (s != '{}')
        $.post("request?set_preferences_data", s);
}

function get_preferences_data() {
    var s = SynchronousRequest('get_preferences_data', []);
    return JSON.parse(s);
}

function dialog_pane_hide() {
    $('.dialog-pane:visible').each(function() {
        $(this).hide();
        applyProxyControlsState();
    });
}

function get_about_info() {
    var s = SynchronousRequest('get_about_info', []);
    return JSON.parse(s);
}

function ecSetup() {
    $('.expand_collapse_area').each(function(indx, element) {

        var sol_id = $(element).parent().attr('id');

        if (!('areaItemState_' + sol_id in window.localStorage))
            window.localStorage['areaItemState_' + sol_id] = "toggle-off";

        var val = window.localStorage['areaItemState_' + sol_id];

        if (val == "toggle-off") {
            $(this).parent().parent().parent().next().show();
            $(element).attr('title', $(element).attr('optitle'));
        } else {
            $(this).parent().parent().parent().next().hide();
            window.localStorage['areaItemState_' + sol_id] = "toggle-on";
            $(element).attr('title', $(element).attr('cltitle'));
        }

        $(element).addClass(window.localStorage['areaItemState_' + sol_id]);
    });

    $(".expand_collapse_area").unbind('click').click(function() {

        if (!timeExpired(this, 200))
            return false;

        var sol_id = $(this).parent().attr('id');
        if ($(this).hasClass("toggle-off")) {
            $(this).removeClass("toggle-off");
            $(this).addClass("toggle-on");
            window.localStorage['areaItemState_' + sol_id] = "toggle-on";
            $(this).attr('title', $(this).attr('cltitle'));
        } else {
            $(this).removeClass("toggle-on");
            $(this).addClass("toggle-off");
            window.localStorage['areaItemState_' + sol_id] = "toggle-off";
            $(this).attr('title', $(this).attr('optitle'));
        }
        $(this).parent().parent().parent().next().toggle();
        return false;
    });
}

function updateUpdatesCount() {
    var cnt = updates_count();
    $('span.digits').text(cnt);

    if (cnt == 0)
        $('span.digits').hide();
    else
        $('span.digits').show();
}

function updateUnvisitedCount() {
    var visited_items = window.localStorage.visited_items ? JSON.parse(window.localStorage.visited_items) : [];
    
    /* This code moved to C++: performance issue
    var sp_list = get_solution_park_list();
    var count = 0;
    
    for (idx in sp_list) {
        var code = sp_list[idx];
        if (visited_items.indexOf(code) == -1 && !is_installed(code) && !need_update(code))
            count++;
    }
    */

    var count = get_unvisited_count(visited_items);

    $('span.digits-sp').text(count);

    if (count == 0)
        $('span.digits-sp').hide();
    else
        $('span.digits-sp').show();
    
}

function setDone(element) {
    $(element).find('.btns').hide();
    $(element).find('.stitle').addClass('stitle-inst');
    $(element).removeClass('downloading');
}

function ConnectionStatusChanged() {
    updateUserInfo();
}

function reloadIndex() {
    SynchronousRequest('reload_index', []);
}
